#include <bits/stdc++.h>
#define ll long long
#define mod 1000000007

using namespace std;

ll a[200010];

int main()
{
    ios_base::sync_with_stdio(0); 
    cin.tie(0);
    ll n, k, rez=0;
    cin >> n >> k;
    for(ll i=0;i<n;i++)
    {
        cin >> a[i];
    }
    if(k==0)
    {
        for(ll i=0;i<n;i++)
        {
            rez+=a[i];
            if(rez>mod) rez%=mod;
        }
    }
    else
    {
        for(ll i=0;i<n;i++)
        {
            rez+=a[i]*(n-i)*(i+1);
            if(rez>mod) rez%=mod;
        }
    }
    cout << rez;
    return 0;
}